import java.awt.*;
import java.math.*;


public class Torus {


    public static double dec1(double x) {
	return(x-Math.floor(x));
    }

    public static double dec2(double x) {
	double y1=x/2.0+1/2.0;
	double y2=dec1(y1);
	double y3=2*y2-1;
	return(y3);
    }

    public static double P(int p,int q) {
	return(2.0*p/(p+q));
    }

    public static double Q(int p,int q) {
	return(2.0*q/(p+q));
    }

    public static double f0(int p,int q,double x,double y) {
	double P=P(p,q);
	return dec2(2*P*x);
    }

    public static double f1(int p,int q,double x,double y) {
	double P=P(p,q);
	return dec2(2*P*y);
    }

    public static double convert(int p,int q,double x) {
	double c=(p+q)/2.0;
	return(c*x);
    }

    public static double P0(int p,int q,double x,double y) {
	double P=P(p,q);
	double t2=P*y-P*P*x+1;
	double t3=dec2(t2);
	return t3;
    }

    public static double Q0(int p,int q,double x,double y) {
	double P=P(p,q);
	double Q=Q(p,q);
	double t2=P*y-P*Q*x+1;
	double t3=dec2(t2);
	return t3;
    }

    public static double P1(int p,int q,double x,double y) {
	double P=P(p,q);
	double t2=P*y+P*P*x+1;
	double t3=dec2(t2);
	return t3;
    }

    public static double Q1(int p,int q,double x,double y) {
	double P=P(p,q);
	double Q=Q(p,q);
	double t2=P*y+P*Q*x+1;
	double t3=dec2(t2);
	return t3;
    }
}

