import java.applet.Applet;
import java.awt.*;
import java.applet.*;
import java.math.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.io.*;
import java.util.*;


public class AGPlot {

    /**For the arithmetic graph*/

    public static void blockPlot(Manager M,Graphics2D g) {
	int p=M.p();
	int q=M.q();
 	double A=1.0*p/q;
	int[] LL=M.P.getLimits();
	int k=LL[0]/(LL[1]-LL[0]);
	Path2D.Double BOX=periodBox(p,q,k);
	int[] L2=GraphicsHelp.getLimits(BOX);
	Path2D.Double gp=new Path2D.Double();

	for(int i=L2[0]-4;i<L2[2]+4;++i) {
	    for(int j=L2[1]-4;j<L2[3]+4;++j) {
		int[] test=AGMap.forwardMap(p,q,i,j);
		int i1=i+test[0];
		int j1=j+test[1];
	       if((BOX.contains(i,j)==true)&&(BOX.contains(i1,j1)==true)) {
		   Complex z0=AGTransforms.k2pAffine(p,q,new Complex(i,j));
		   Complex z1=AGTransforms.k2pAffine(p,q,new Complex(i1,j1));
	           gp.moveTo(z0.x,z0.y);
		   gp.lineTo(z1.x,z1.y);
		}
	    }
	}
	gp=M.P.transform(gp);
	g.setColor(M.C.AG.M[0].C);
	g.setStroke(new BasicStroke(2));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    /**Gets the bounding box for the arithmetic graph*/

    public static Path2D.Double periodBox(int p,int q,int k) {
	Path2D.Double gp=new Path2D.Double();
 	double t=.00001;
	double s=p+q;
	double[][] d={{k-t,-1-t},{k-t,1+t},{k+1+t,1+t},{k+1+t,-1-t}};
	for(int i=0;i<4;++i) {
	    Complex u=new Complex(s*d[i][0],s*d[i][1]);
	    Complex z=AGTransforms.p2kAffine(p,q,u);
	    if(i==0) gp.moveTo(z.x,z.y);
	    if(i!=0) gp.lineTo(z.x,z.y);
	}
	gp.closePath();
	return(gp);
    }





    public static void firstPolygon(Manager M,Graphics2D g,boolean trans) {
        Path2D.Double gp=new Path2D.Double();
	int p=M.p();
	int q=M.q();
	double A=1.0*p/q;
	double LIM=50000;
	int count=0;
	int closed=0;	
	int[] pos=new int[2];

	int halt=1;
	gp.moveTo(0,0);
	Complex z=AGTransforms.k2pAffine(p,q,new Complex(0,0));
	gp.moveTo(0,0);
	if(trans==true) gp.moveTo(z.x,z.y);

       	while((halt==1)&&(count<LIM)) {
	    int[] test=AGMap.forwardMap(p,q,pos[0],pos[1]);

	    pos[0]=pos[0]+test[0];
	    pos[1]=pos[1]+test[1];
	    z=AGTransforms.k2pAffine(p,q,new Complex(pos[0],pos[1]));
	    if(trans==false) gp.lineTo(pos[0],pos[1]);
	    if(trans==true) gp.lineTo(z.x,z.y);
	    if((pos[0]==0)&&(pos[1]==0)) closed=1;
	    if(closed==1) halt=0;
	    ++count;
	}
	halt=0;
	gp=M.P.transform(gp);
	g.setColor(M.C.AG.M[1].C);
	g.setStroke(new BasicStroke(2));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }



    public static void drawAGLattice(Manager M,Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	int p=M.p();
	int q=M.q();
	int[] L=M.P.getLimits();
	for(int k=0;k<4;++k) {
	    int t=M.C.GRID.L[k].on;
	    if(t==1) {
		for(int i=-L[0]-1;i<L[1]+1;++i) {
	          for(int j=-1;j<L[1]-L[0]+1;++j) {
		     gp=AGLattice.grid(k,p,q,i,j);
		     gp=M.P.transform(gp);
	             g.setColor(M.C.AG.M[2].C);
	             g.draw(gp);
		  }
	       }
	    }
	}
    }

    public static void drawPixelFail(Manager M,Graphics2D g) {
	int p=M.p();
	int q=M.q();
	int[] L=M.P.getLimits();

	for(int i=L[0];i<L[1];++i) {
	    for(int j=0;j<L[1]-L[0];++j) {
              if(AGLattice.goodPoint(p,q,i+.5,j+.5)==true) {
		  int test=pixel(p,q,i,j);
		  Tile T=new Tile(p,q,i,j);
                  Path2D.Double gp=T.getSquare();
		  gp=M.P.transform(gp);
		  g.setColor(new Color(30,40,50));
		  if(test==0) g.setColor(Color.black);
		  if(test==2) g.setColor(new Color(100,110,120));
		  g.fill(gp);
		  g.setColor(M.C.MODEL.M[2].C);
		  g.draw(gp);
	      }
	    }
	}
    }

    public static void drawTest(Manager M,Graphics2D g) {
	int p=M.p();
	int q=M.q();
	int[] L=M.P.getLimits();
	double P=2.0*p/(p+q);

	for(int i=L[0];i<L[1];++i) {
	    for(int j=0;j<L[1]-L[0];++j) {
		double[] U=PlaidClassifyingMap.mapBasic(P,i+.5,j+.5);
		Tile T=new Tile(p,q,i,j);
                Path2D.Double gp=T.getSquare();
		gp=M.P.transform(gp);
		g.setColor(new Color(0,0,100,100));
		if(U[1]>U[0]) g.setColor(new Color(100,0,0,180));
		if(Math.abs(U[1]-U[0])<.000001) g.setColor(new Color(50,50,50,180));
		if(U[0]<-.999999) g.setColor(new Color(100,0,100,180));
		if(U[1]<-.999999) g.setColor(new Color(100,0,100,180));
		if(U[0]>.999999) g.setColor(new Color(100,0,100,180));
		if(U[1]>.999999) g.setColor(new Color(100,0,100,180));
		  g.fill(gp);
	    }
	}
    }





    public static int pixel(int p,int q,int i,int j) {
	Tile T=new Tile(p,q,i,j);
	int[] test1=PlaidClassify.classify(T);
        Complex w1=AGLattice.nearestGrid(p,q,i+.5,j+.5);
	Complex w2=AGTransforms.p2kAffine(p,q,w1);
	int[] i1=AGMap.forwardMap(p,q,w2.x,w2.y);
	int[] i2=AGMap.backwardMap(p,q,w2.x,w2.y);
	int j1=Spider.codon0(p,q,w1,i1[0],i1[1]);
	int j2=Spider.codon0(p,q,w1,i2[0],i2[1]);
	int[] test2={j1,j2};
	boolean same=isSame(test1,test2);
	if(same==true) return 1;
	return 2;
    }

    public static boolean isSame(int[] a,int[] b) {
	if((a[0]==a[1])&&(b[0]==b[1])) return true;
	if((a[0]==b[0])&&(a[1]==b[1])) return true;
	if((a[0]==b[1])&&(a[1]==b[0])) return true;
	return(false);
    }










}

