import java.awt.*;
import java.math.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.Arrays;

public class AGTest {


    public static void main(int p,int q) {
	System.out.println("start");
	int[][] BAD=getCriticalGlitches(p,q);
	for(int i=0;i<BAD.length;++i) {
	    for(int j=i+1;j<BAD.length;++j) {
		boolean test=isSwitched(BAD[i],BAD[j]);
		if(test==true) {
		    System.out.println("------------");
		    System.out.println(BAD[i][0]+" "+BAD[i][1]+" "+BAD[i][2]);
		    System.out.println(BAD[j][0]+" "+BAD[j][1]+" "+BAD[j][2]);
		}
	    }
	}
	System.out.println("done");
    }

    public static boolean isSwitched(int[] A,int[] B) {
	if(A[0]==B[0]) return(false);
	if(A[0]-B[0]>1) return(false);
	if(B[0]-A[0]>1) return(false);
	if(A[1]-B[1]>2) return(false);
	if(B[1]-A[1]>2) return(false);
	if(A[2]==B[2]) return(false);
	return(true);
    }



    public static int[][] getCriticalGlitches(int p,int q) {
	int[][] BAD=getGlitches(p,q);
	int[] CRIT=getCritical(BAD);
	int[][] BAD2=new int[BAD.length][3];
	int count=0;
	for(int i=0;i<BAD.length;++i) {
	    if(nearList(BAD[i][0],CRIT)==true) {
		BAD2[count][0]=BAD[i][0];
		BAD2[count][1]=BAD[i][1];
		BAD2[count][2]=BAD[i][2];
		++count;
	    }
	}
	int[][] BAD3=new int[count][3];
	for(int i=0;i<count;++i) {
	    BAD3[i][0]=BAD2[i][0];
	    BAD3[i][1]=BAD2[i][1];
	    BAD3[i][2]=BAD2[i][2];
	}
	System.out.println("done");
	return(BAD3);
    }


    public static boolean nearList(int x,int[] X) {
	for(int i=0;i<X.length;++i) {
	    if(Math.abs(X[i]-x)<1.5) return(true);
	}
	return(false);
    }

    public static int[] getCritical(int[][] BAD) {
	int[] CRIT=new int[BAD.length];
	int count=0;
	for(int i=0;i<BAD.length-1;++i) {
	    int d1=BAD[i][0];
	    int d2=BAD[i+1][0];
	    int e=d2-d1;
	    if((e>.5)&&(e<1.5)) {
		CRIT[count]=d1;
		++count;
	    }
	}
	int[] CRIT2=new int[count];
	for(int i=0;i<count;++i) CRIT2[i]=CRIT[i];
	return(CRIT2);
    }


    public static int[][] getGlitches(int p,int q) {
	Complex[] Z1=rawAG(p,q);
	Complex[] Z2=rawPlaid(p,q);
	int[][] d1=lex(Z1);
	int[][] d2=lex(Z2);
	int count=0;
	int[][] BAD=new int[(p+q)*(p+q)][3];
	for(int i=0;i<d2.length;++i) {
	    int e=d1[i][1]-d2[i][1];
	    if(e!=0) {
		BAD[count][0]=d1[i][0];
		BAD[count][1]=d1[i][1];
		if(e<0) BAD[count][2]=-2;
		if(e>0) BAD[count][2]=2;
		if(e*e>4) {
                     System.out.println("bad "+e);
		     System.out.println(d1[i][0]+" "+d1[i][1]);
		     System.out.println(d2[i][0]+" "+d2[i][1]);
		}
		++count;
	    }
	}
	int[][] BAD2=new int[count][3];
	for(int i=0;i<count;++i) {
	    for(int j=0;j<3;++j) BAD2[i][j]=BAD[i][j];
	}
	return(BAD2);

    }

    public static int[][] lex(Complex[] Z) {
	int[][] d=toArray(Z);
	d=lex(d);
	return(d);
    }


    public static int[][] lex(int[][] d) {
	long[] e=new long[d.length];
	for(int i=0;i<e.length;++i) e[i]=10000*d[i][0]+d[i][1];
	Arrays.sort(e);
	int[][] f=new int[e.length][2];
	for(int i=0;i<e.length;++i) {
	    f[i][0]=(int)(e[i]/10000);
	    f[i][1]=(int)(e[i]-10000*f[i][0]);
	}
	return(f);
    }

    /**This cleans off the AG case, moving the y-coordinate to
       half integers.*/

    public static int cleanInt(double d) {
	int n=(int)(Math.floor(d+.5));
	return(n);
    }

    public static int[][] toArray(Complex[] Z) {
	int[][] d=new int[Z.length][2];
	for(int i=0;i<Z.length;++i) {
	    d[i][0]=cleanInt(Z[i].x);
	    d[i][1]=(int)(2*Math.floor(Z[i].y)+1);
	}
	return(d);
    }

    public static Complex[] rawAG(int p,int q) {
	int LIM=p+q;
	LIM=LIM*LIM*LIM;
	Complex[] Z=new Complex[LIM];
	int count=0;
 	double A=1.0*p/q;
	Path2D.Double BOX=Displays.periodBox(p,q);
	BOX=AGTransforms.map(p,q,BOX);
	int[] L2=GraphicsHelp.getLimits(BOX);
	Path2D.Double gp=new Path2D.Double();

	for(int i=L2[0]-4;i<L2[2]+4;++i) {
	    for(int j=L2[1]-4;j<L2[3]+4;++j) {
	       gp.reset();
	       int[] test1=AGMap.forwardMap(p,q,i,j);
	       int[] test2=AGMap.backwardMap(p,q,i,j);
               int i1=i+test1[0];
	       int j1=j+test1[1];
	       int i2=i+test2[0];
	       int j2=j+test2[1];
	       if((BOX.contains(i,j)==true)&&(BOX.contains(i1,j1)==true)) {
		   Complex z0=new Complex(i,j);
		   Complex z1=new Complex(i1,j1);
		   Complex z2=new Complex(i2,j2);
		   Complex w0=AGTransforms.inverseMap(p,q,z0);
		   Complex w1=AGTransforms.inverseMap(p,q,z1);
		   Complex w2=AGTransforms.inverseMap(p,q,z2);
		   Complex[] V=vertical(w0,w1,w2);


		   if(V!=null) {
		       for(int jj=0;jj<V.length;++jj) {
		          if(onList(V[jj],Z,count)==false) {
		              Z[count]=new Complex(V[jj]);
		              ++count;
			  }
		       }
		   }
		}
	    }
	}
	return trim(Z,count);
    }

    public static Complex[] mergeList(Complex[] Z1,Complex[] Z2) {
	if((Z1==null)&&(Z2==null)) return null;
	if(Z1==null) return Z2;
	if(Z2==null) return Z1;
	Complex[] Z3=new Complex[Z1.length+Z2.length];
	int count=0;
	for(int i=0;i<Z1.length;++i) {
	    Z3[count]=new Complex(Z1[i]);
	    ++count;
	}
	for(int i=0;i<Z2.length;++i) {
	    Z3[count]=new Complex(Z2[i]);
	    ++count;
	}
	return(Z3);
    }


    public static Complex[] vertical(Complex z0,Complex z1,Complex z2) {
	boolean debug=false;
	boolean test=specialPass(z0,z1,z2);
	if(test==true) {
	    Complex[] Z={z0};
	    return(Z);
	}
	test=specialFail(z0,z1,z2);
	Complex[] Z1=vertical(z0,z1);
	Complex[] Z2=vertical(z0,z2);
	Z1=prune(z0,Z1,test);
	Z2=prune(z0,Z2,test);
	return mergeList(Z1,Z2);
    }

    public static Complex[] prune(Complex z,Complex[] Z,boolean test) {
	if(Z==null) return null;
	if(test==false) return(Z);
	Complex[] W=new Complex[Z.length-1];
	for(int i=0;i<W.length;++i) W[i]=new Complex(Z[i+1]);
	return(W);
    }



    public static Complex[] vertical(Complex z1,Complex z2) {
	boolean test1=special(z1);
	boolean test2=special(z2);
	if(test1==false) return verticalGeneric(z1,z2);
	if((test1==true )&&(test2==false)) return verticalSpecial(z1,z2);
	return(null);
    }

    public static boolean specialFail(Complex z0,Complex z1,Complex z2) {
	if(special(z0)==false) return(false);
	if((z1.x>z0.x)&&(z2.x>z0.x)) return(true);
	if((z1.x<z0.x)&&(z2.x<z0.x)) return(true);
	return(false);
    }

    public static boolean specialPass(Complex z0,Complex z1,Complex z2) {
	if(special(z0)==false) return(false);
	if(special(z1)==false) return(false);
	if(special(z2)==false) return(false);
	if(Math.abs(z1.x-z2.x)<.5) return(false);
	return(true);
    }

    public static boolean special(Complex z1) {
	double d=Math.floor(z1.x+.5);
	if(Math.abs(z1.x-d)<.00000001) return true;
	return false;
    }

    /**nothing is on an integer vertical line*/

    public static Complex[] verticalGeneric(Complex z1,Complex z2) {
	double d1=Math.floor(z1.x);
	double d2=Math.floor(z2.x);
	if(special(z2)==true) d2=z2.x;
	if(Math.abs(d1-d2)<.5) return null;
	if(Math.abs(d1-d2)<1.5) {
	   double d3=Math.max(d1,d2);
	   Complex w=Vector.findCross(z1,z2,new Complex(d3,0),new Complex(d3,1));
	   Complex[] W={w};
	   return(W);
	}
        double d3=Math.max(d1,d2);
	Complex w1=Vector.findCross(z1,z2,new Complex(d3-1,0),new Complex(d3-1,1));
        Complex w2=Vector.findCross(z1,z2,new Complex(d3,0),new Complex(d3,1));
	Complex[] W={w1,w2};
	return(W);
    }

    /**first point is on an integer vertical line,
       second point is not.*/

    public static Complex[] verticalSpecial(Complex z1,Complex z2) {
	if(Math.abs(z1.x-z2.x)<1) {
	    Complex[] W={z1};
	    return(W);
	}
	if(z2.x-z1.x>1) {
	   double d3=Math.floor(z2.x);
           Complex w1=Vector.findCross(z1,z2,new Complex(d3,0),new Complex(d3,1));
	   Complex[] W={z1,w1};
	   return(W);
	}

	if(z1.x-z2.x>1) {
	   double d3=z1.x-1;
           Complex w1=Vector.findCross(z1,z2,new Complex(d3,0),new Complex(d3,1));
	   Complex[] W={z1,w1};
	   return(W);
	}
	return(null);
    }







    public static int[] getLimits(int p,int q,int k) {
	int omega=p+q;
	int[] L={k*omega,k*omega+omega};
	return(L);
    }

    public static Complex[] rawPlaid(int p,int q) {

	Tile T=new Tile();
	int w=p+q;
	int LIM=w*w*w;
	Complex[] Z=new Complex[LIM];
	int count=0;
	Path2D.Double gp=new Path2D.Double();

	for(int i=0;i<w*w;++i) {
	    for(int j=0;j<w;++j) {
		T=new Tile(p,q,i,j);
		int[] u=PlaidModel.typeOrientedCheap(T);
		for(int jj=0;jj<2;++jj) {
		    if(u[jj]%2==1) {
			double t=i;
			if(u[jj]==3) t=i+1;
			Complex z=new Complex(t,j+.5);
			if(onList(z,Z,count)==false) {
			   Z[count]=new Complex(z);
		           ++count;
			}
		    }
		}
	    }
	}
	return trim(Z,count);
    }



    public static Complex[] trim(Complex[] Z,int count) {
	Complex[] Z2=new Complex[count];
	for(int i=0;i<count;++i) Z2[i]=new Complex(Z[i]);
	return(Z2);
    }

    public static boolean onList(Complex z,Complex[] Z,int count) {
	for(int i=0;i<count;++i) if(Complex.dist(z,Z[i])<.0000001) return(true);
	return false;
    }





}

