import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;


public class GraphPETCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    Color[] COLOR=new Color[7];
    Point JX;

    public GraphPETCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(100,300,180);	
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g); 


      if(M.C.GRAPH.L[0].on==1) drawPartition(g,false);
      if(M.C.GRAPH.L[1].on==1) drawPartition(g,true);

      try{
      if(M.Z.SC.choice!=-1) SpiderRender.drawSpiderCheck(M,this,g);
      if(M.Z.SC.MODE.mode<=1) SpiderRender.drawSpider(M,this,g);
      if(M.Z.SC.MODE.mode==2) SpiderRender.drawSpiderIntersect(M,this,g);
      }
      catch(Exception e) {}


      if(M.C.GRAPH.L[2].on==1) drawTriples(g,false);
      if(M.C.GRAPH.L[3].on==1) drawTriples(g,true);
      if(M.C.GRAPH.L[4].on==1) drawTarget(0,g);
      if(M.C.GRAPH.L[5].on==1) drawTarget(1,g);
      if(M.C.GRAPH.L[6].on==1) drawTarget(g);
      if(M.C.GRAPH.L[7].on==1) drawRecovery(g);
      drawImage(g);
   }

    /**This draws the current selected point
       in the PET*/

    public void drawImage(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(SOURCE.x,SOURCE.y);
	gp.lineTo(SOURCE.x,SOURCE.y);
	gp=transform(gp);
	g.setColor(Color.white);
	g.setStroke(new BasicStroke(5));
	g.fill(gp);
	g.draw(gp);
	g.setColor(Color.black);
	g.setStroke(new BasicStroke(2));
	g.fill(gp);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,0,0));
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawPartition(Graphics2D g,boolean select) {
	GraphPolytopes GR=new GraphPolytopes();
	int c=M.GS.PARTITION.mode;
	int s=M.GS.DIRECTION.mode; 
        double t=M.GS.S[s];
	double A=M.GS.PAR;
	int lim1=0;
	int lim2=14;
	if(c==1) {
	    lim1=14;
	    lim2=28;
	}

	int cc=M.GS.TILE.val;
	for(int q1=-cc;q1<=cc;++q1) {
	    for(int q2=-cc;q2<=cc;++q2) {
		for(int q3=-cc;q3<=cc;++q3) {
		    for(int k=lim1;k<lim2;++k) {
			Polytope P=GR.P[k];
			P=GraphPolytopeMoves.shift(q1,q2,q3,P);
			if(c==0) P=Polytope.shift(new Vector4(0,-1,0,0),P);
			if(c==1) P=Polytope.shift(new Vector4(1,0,0,0),P);
                        PolygonWrapper SP=P.slice(s,t,A);
	                if(SP!=null) { 
                            int t1=P.type[1];
            	            int t2=P.type[2];
			    Color C=GraphPETColors.COLOR[t1+1][t2+1];
			    int[] I={q1,q2,q3,k};
			    boolean test=false;
			    try{
			      test=match(c,M.Z.TS.getIndex(),I);
			    }
			    catch(Exception e) {}
			    if((select==false)||(test==true)) {
			      Path2D.Double gp=SP.toPath2D();
			      fillPoly(g,gp,C);
			    }
			}
		    }
		}
	    }
	}
    }

    public boolean match(int direction,int choice,int[] I) {
	int[][] J={{0}};
	if(direction==0) J=DataTripleIndex.indexPlus(choice);
	if(direction==1) J=DataTripleIndex.indexMinus(choice);
	for(int i=0;i<J.length;++i) {
	    if(match(I,J[i])==true) return(true);
	}
	return(false);
    }


    public boolean match(int[] J,int[] K) {
	for(int i=0;i<4;++i) {
	    if(J[i]!=K[i]) return false;
	}
	return true;
    }




    public void drawTarget(Graphics2D g) {
	drawTarget0(g);
	drawTarget1(g);
    }

    public void drawTarget0(Graphics2D g) {
	int[][] ON=M.Z.SC.getOn();
	if(ON.length<2) return;
	PolygonWrapper[] LIST0=getPolyTarget(1,ON[0][0],ON[0][1]);
	PolygonWrapper[] LIST1=getPolyTarget(0,ON[1][0],ON[1][1]);
	for(int i=0;i<LIST0.length;++i) {
	    for(int j=0;j<LIST1.length;++j) {
		PolygonWrapper X=PolygonWrapper.intersect(LIST0[i],LIST1[j]); 
		if(X!=null) {
                   Path2D.Double gp=X.toPath2D();
                   fillPoly(g,gp,new Color(150,160,170));
		}
	    }
	}
    }


    public void drawTarget1(Graphics2D g) {
	int[][] ON=M.Z.SC.getOn();
	if(ON.length<2) return;
	PolygonWrapper[] LIST0=getPolyTarget(0,ON[0][0],ON[0][1]);
	PolygonWrapper[] LIST1=getPolyTarget(1,ON[1][0],ON[1][1]);
	for(int i=0;i<LIST0.length;++i) {
	    for(int j=0;j<LIST1.length;++j) {
		PolygonWrapper X=PolygonWrapper.intersect(LIST0[i],LIST1[j]);	               if(X!=null) {
                   Path2D.Double gp=X.toPath2D();
                   fillPoly(g,gp,new Color(150,160,170));
		}                  
	    }
	}
    }


    public void drawTarget(int c,Graphics2D g) {
	int[][] ON=M.Z.SC.getOn();
	if(ON.length==0) return;
	PolygonWrapper[] LIST=getPolyTarget(c,ON[0][0],ON[0][1]);
	for(int i=0;i<LIST.length;++i) {
	    Path2D.Double gp=LIST[i].toPath2D();
	    Color C=GraphPETColors.COLOR[LIST[i].t1+1][LIST[i].t2+1];
	    fillPoly(g,gp,C);
	}
    }

    public PolygonWrapper[] getPolyTarget(int c,int u1,int u2) {
	PolygonWrapper[] LIST=new PolygonWrapper[500];
	int count=0;
	int lim=1;
	for(int q1=-lim;q1<=lim;++q1) {
	    for(int q2=-lim;q2<=lim;++q2) {
		PolygonWrapper[] NEW=getPoly(c,q1,q2,0,u1,u2);
		for(int k=0;k<NEW.length;++k) {
		    if((NEW[k].t1==u1)&&(NEW[k].t2==u2)) {
			LIST[count]=new PolygonWrapper(NEW[k]);
			++count;
		    }
		}
	    }
	}
	return ListHelp.trim(LIST,count);
    }


    public PolygonWrapper[] getPoly(int c) {
	PolygonWrapper[] LIST=new PolygonWrapper[500];
	int count=0;
	int lim=1;
	for(int q1=-lim;q1<=lim;++q1) {
	    for(int q2=-lim;q2<=lim;++q2) {
		PolygonWrapper[] NEW=getPoly(c,q1,q2,0);
		for(int k=0;k<NEW.length;++k) {
		   LIST[count]=new PolygonWrapper(NEW[k]);
		   ++count;
		}
	    }
	}
	return ListHelp.trim(LIST,count);
    }




    public PolygonWrapper[] getPoly(int c,int q1,int q2,int q3) {
	int count=0;
	PolygonWrapper[] LIST=new PolygonWrapper[14];
	int s=M.GS.DIRECTION.mode;  
        double t=M.GS.S[s];
	double A=M.GS.PAR;
	Vector4 V=new Vector4(0,-1,0,0);
	int lim1=0;
	int lim2=14;
	if(c==1) {
	    V=new Vector4(1,0,0,0);
	     lim1=14;
	     lim2=28;
	}
	Path2D.Double gp=new Path2D.Double();
	GraphPolytopes X=new GraphPolytopes();
        for(int i=lim1;i<lim2;++i) { 
	    Polytope P=GraphPolytopeMoves.shift(q1,q2,q3,X.P[i]);
	    P=Polytope.shift(V,P);
	    PolygonWrapper SP=P.slice(s,t,A);
	    if(SP!=null) { 
                SP.t1=X.P[i].type[1];
	        SP.t2=X.P[i].type[2];
		LIST[count]=new PolygonWrapper(SP);
		++count;
	    }
	}
	return ListHelp.trim(LIST,count);
    }



    public PolygonWrapper[] getPoly(int c,int q1,int q2,int q3,int u1,int u2) {
	int count=0;
	PolygonWrapper[] LIST=new PolygonWrapper[14];
	int s=M.GS.DIRECTION.mode;  
        double t=M.GS.S[s];
	double A=M.GS.PAR;
	Vector4 V=new Vector4(0,-1,0,0);
	int lim1=0;
	int lim2=14;
	if(c==1) {
	    V=new Vector4(1,0,0,0);
	     lim1=14;
	     lim2=28;
	}
	Path2D.Double gp=new Path2D.Double();
	GraphPolytopes X=new GraphPolytopes();
        for(int i=lim1;i<lim2;++i) { 
	    if((X.P[i].type[1]==u1)&&(X.P[i].type[2]==u2)) {
	      Polytope P=GraphPolytopeMoves.shift(q1,q2,0,X.P[i]);
	      P=Polytope.shift(V,P);
	      PolygonWrapper SP=P.slice(s,t,A);
	      if(SP!=null) { 
                SP.t1=X.P[i].type[1];
	        SP.t2=X.P[i].type[2];
		LIST[count]=new PolygonWrapper(SP);
		++count;
	      }
	    }
	}
	return ListHelp.trim(LIST,count);
    }

    public void drawPoly(Graphics2D g,Path2D.Double gp,Color C) {
       gp=transform(gp);
       g.setColor(C);
       g.draw(gp);
    }

    public void fillPoly(Graphics2D g,Path2D.Double gp,Color C) {
       gp=transform(gp);
       g.setColor(C);
       g.fill(gp);  
       g.setColor(Color.white);
       g.draw(gp);
    }


    /**draws the triple partition.*/

    public void drawTriples(Graphics2D g,boolean select) {
	int s=0;
	int dyn=0;
	double t=0;
	double A=0;
	try{
	  s=M.GS.DIRECTION.mode; 
          t=M.GS.getSlice();
	  A=M.GS.getParameter();
	}
	catch(Exception e) {}
	try{
	  dyn=M.QS.DYNAMICS.mode;
	}
	catch(Exception e) {}

	for(int i=0;i<218;++i) {
	    Polytope X=GraphTriples.P(i);
	    boolean DRAWME=true;
	    try{
		if(select==true) DRAWME=M.Z.TS.matchesCode(X,i);
	    }
	    catch(Exception e) {}
	    if(DRAWME==true) {
            PolygonWrapper SPOLY=X.slice(s,t,A);
	    if(SPOLY!=null) {
	       Path2D.Double gp=SPOLY.toPath2D();
               int t1=0;
	       int t2=0;
	       if(dyn==0) {t1=X.code[2];t2=X.code[3];}
	       if(dyn==1) {t1=X.code[4];t2=X.code[5];}
	       if(dyn==2) {t1=X.code[0];t2=X.code[1];}
               Color C=PlaidPETColors.COLOR[t1][t2];
	       if(select==false) fillPoly(g,gp,C);
	       if(select==true) {
		   g.setStroke(new BasicStroke(3));
		   drawPoly(g,gp,Color.white);
		   g.setStroke(new BasicStroke(1));
	       }

	    }}
	}


    }


    public void drawRecovery(Graphics2D g) {
	int s=0;
	double A=0;
	try{
	  s=M.GS.DIRECTION.mode; 
          A=M.GS.getParameter();
	}
	catch(Exception e) {}  
	if(s!=0) return;     
        g.setStroke(new BasicStroke(3));
	Path2D.Double gp=new Path2D.Double();

	for(int i=-2;i<3;++i) {
	    gp.reset();
	    gp.moveTo(-4,i);
	    gp.lineTo(4,i);
	    gp=transform(gp);
	    g.setColor(Color.yellow);
	    g.draw(gp);
	}

	for(int j=-2;j<=2;++j) {
	    gp.reset();
	    gp.moveTo(-2*A+j*(1+A),-2);
	    gp.lineTo(+2*A+j*(1+A),+2);
	    gp=transform(gp);
	    g.setColor(Color.yellow);
	    g.draw(gp);
	}
    }


    public void mousePressed(MouseEvent e) { }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) { 
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	repaint();
    }

     public void mouseReleased(MouseEvent e) {	 
     }

    public void mouseEntered(MouseEvent e) {
	requestFocus();
    }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	JX=J.X;
     }

   
     public void mouseDragged(MouseEvent e) {
     }


    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
	int test=0;
	if(ch=='z') test=1;
	if(ch=='x') test=2;
	if(ch=='c') test=3;
	if(test>0) doMouseClick(test);
    }

 
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}


}

