import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class PlaidPETIntersector {
    ListenSquare[][] T=new ListenSquare[3][3];
    int BACK,MID,FRONT;
    SelectInteger[] BA=new SelectInteger[4];
    SelectInteger[] FR=new SelectInteger[4];
    SelectInteger[] MI=new SelectInteger[4];
    int X;
    int Y;
    Manager M;

    public PlaidPETIntersector(Manager m,int x,int y) {
	M=m;
	X=x;
	Y=y;
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		T[i][j]=new ListenSquare(X+60*i,Y+120-60*j,60,60);
	    }
	}
	BA[0]=new SelectInteger(X,Y+225,40,20,0,0,0,1);
	MI[0]=new SelectInteger(X+65,Y+225,40,20,0,0,0,1);
	FR[0]=new SelectInteger(X+127,Y+225,40,20,0,0,0,1);

	for(int i=1;i<4;++i) {
	    BA[i]=new SelectInteger(X,Y+235+25*i,40,20,0,-1,1,1);
	    MI[i]=new SelectInteger(X+65,Y+235+25*i,40,20,0,-1,1,1);
	    FR[i]=new SelectInteger(X+125,Y+235+25*i,40,20,0,-1,1,1);
	}
    }

    public Polytope[] getPolytopes() {
	int[] J=getTriple();
	int[] b=new int[4];
	int[] m=new int[4];
	int[] f=new int[4];
	for(int i=0;i<4;++i) {
	    b[i]=BA[i].val;
	    m[i]=MI[i].val;
	    f[i]=FR[i].val;
	}


	int[] m0=PlaidPolytopes.typeIndex(J[0],J[1]);
	if((b[1]+b[2]+b[3]+10)%2==1)  m0=PlaidPolytopes.typeIndex(J[1],J[0]);


	int[] m1=PlaidPolytopes.typeIndex(J[2],J[3]);


	int[] m2=PlaidPolytopes.typeIndex(J[4],J[5]);
	if((f[1]+f[2]+f[3]+10)%2==1)  m2=PlaidPolytopes.typeIndex(J[5],J[4]);


	int n0=m0[b[0]];
	int n1=m1[m[0]];
	int n2=m2[f[0]];
	PlaidPolytopes X=new PlaidPolytopes();
	Polytope P0=X.P[n0];
	Polytope P1=X.P[n1];
	Polytope P2=X.P[n2];

	P0=PlaidPolytopeMoves.shift(b[1],b[2],b[3],P0);
	P2=PlaidPolytopeMoves.shift(f[1],f[2],f[3],P2);
	P0=PlaidPolytopeMoves.map(2,P0);
	P2=PlaidPolytopeMoves.map(1,P2);
	Polytope[] LIST={P0,P1,P2};
	return(LIST);
    }



    public int[] getTriple() {
	int[] I2=convert(MID);
	int back=partnerBack(I2[0],BACK);
	int front=partnerFront(I2[1],FRONT);;
	int[] I1=convert(back);
	int[] I3=convert(front);
	int[] J={I1[0],I1[1],I2[0],I2[1],I3[0],I3[1]};
	return(J);
    }

    public int[] getNumbers() {
	int[] J=getTriple();
 	int a1=PlaidPolytopes.numberIndex(J[0],J[1]);
	int a2=PlaidPolytopes.numberIndex(J[2],J[3]);
	int a3=PlaidPolytopes.numberIndex(J[4],J[5]);
	int[] a={a1,a2,a3};
	return(a);
    }

    public void render(Graphics2D g) {
	int[] J=getTriple();
	int[] N=getNumbers();
	g.setColor(Color.black);
	g.fillRect(X,Y,180,330);
	g.setColor(Color.white);
	g.drawRect(X,Y,180,180);
	g.drawRect(X,Y,180,205);
	g.drawRect(X,Y,180,330);
	for(int i=0;i<4;++i) {
	    Color BC=M.C.PPC.getColor(J[0],J[1]);
	    BA[i].render(g,BC,Color.white,Color.white);
	    Color MC=M.C.PPC.getColor(J[2],J[3]);
	    if(i==0) MI[i].render(g,MC,Color.white,Color.white);
	    Color FC=M.C.PPC.getColor(J[4],J[5]);
	    FR[i].render(g,FC,Color.white,Color.white);
	}
        g.setFont(new Font("Helvetica",Font.PLAIN,16));
	g.setColor(Color.white);
	int offset=10;
	for(int i=0;i<6;++i) {
	    Integer JJ=new Integer(J[i]);
	    g.drawString(JJ.toString(),X+offset,Y+200);
	    offset=offset+20;
	    if(i%2==1) offset=offset+20;
	}

        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(new Color(255,150,0));
	offset=17;
	for(int i=0;i<3;++i) {
	    Integer NN=new Integer(N[i]);
	    g.drawString(NN.toString(),X+offset,Y+218);
	    offset=offset+63;
	}

	render1(g);
	render2(g);
    }

    public void render1(Graphics2D g) {
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) { 
		int[] I=convert(MID);
		if((i==1)&&(j==1)) render1(g,T[i][j],MID);
		boolean test=good(I[0],i-1,j-1);
		if(test==true) render1(g,T[i][j],partnerBack(I[0],BACK));
		test=good(I[1],i-1,j-1);
		if(test==true) render1(g,T[i][j],partnerFront(I[1],FRONT));
	    }
	}
    }

    public void render2(Graphics2D g) {
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) { 
		int[] I=convert(MID);
		if((i==1)&&(j==1)) render2(g,T[i][j],MID);
		boolean test=good(I[0],i-1,j-1);
		if(test==true) render2(g,T[i][j],partnerBack(I[0],BACK));
		test=good(I[1],i-1,j-1);
		if(test==true) render2(g,T[i][j],partnerFront(I[1],FRONT));
	    }
	}
    }

    public int[] convert(int k) {
	int[][] I={{0,1},{0,2},{0,3},{1,0},{1,2},{1,3},{2,0},{2,1},{2,3},{3,0},{3,1},{3,2}};
	return I[k];
    }

    public void advanceMID(Point X) {
	if(T[1][1].inside(X)==1) ++MID;
	if(MID==12) MID=0;
    }

    public void advanceBACK(Point X) {
	int[] I=convert(MID);
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		boolean test=good(I[0],i-1,j-1);
		if(test==true) {
	          if(T[i][j].inside(X)==1) ++BACK;
		}
	    }
	}
	if(BACK==3) BACK=0;
    }

    public void advanceFRONT(Point X) {
	int[] I=convert(MID);
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		boolean test=good(I[1],i-1,j-1);
		if(test==true) {
	          if(T[i][j].inside(X)==1) ++FRONT;
		}
	    }
	}
	if(FRONT==3) FRONT=0;
    }


    public int partnerFront(int i,int j) {
	int[][] a={{6,7,8},{9,10,11},{0,1,2},{3,4,5}};
	return(a[i][j]);
    }

    public int partnerBack(int i,int j) {
	int[][] a={{1,4,11},{2,5,8},{3,6,9},{0,7,10}};
	return(a[i][j]);
    }

    public void selectPolytope(Point X) {
	int[] a=getNumbers();
	BA[0].max=a[0];
	MI[0].max=a[1];
	FR[0].max=a[2];
	for(int i=0;i<4;++i) {
	    BA[i].modify(X);
	    MI[i].modify(X);
	    FR[i].modify(X);
	    if(BA[0].val==BA[0].max) --BA[0].val;
	    if(MI[0].val==MI[0].max) --MI[0].val;
	    if(FR[0].val==FR[0].max) --FR[0].val;
	}
    }

    public void process(Point X) {
	advanceMID(X);
	advanceBACK(X);
	advanceFRONT(X);
	selectPolytope(X);
    }


    public void render1(Graphics2D g,ListenSquare t,Integer k) {
	int[] I=convert(k);
	Color C=M.C.PPC.getColor(I[0],I[1]);
	t.render(g,C);
    }

    public void render2(Graphics2D g,ListenSquare t,Integer k) {
	int[] I=convert(k);
	Complex z1=getMidpoint(t,I[0]);
	Complex z2=getMidpoint(t,I[1]);
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(z1.x,z1.y);
	gp.lineTo(z2.x,z2.y);
	g.setColor(Color.white);
	g.setStroke(new BasicStroke(2));
	g.draw(gp);
	gp.reset();
	gp.moveTo(z2.x,z2.y);
	gp.lineTo(z2.x,z2.y);
	g.setStroke(new BasicStroke(7));
	g.draw(gp);	
        g.setStroke(new BasicStroke(1));
    }



    public Complex getMidpoint(ListenSquare t,int k) {
	double x=t.x;
	double y=t.y;
	double h2=1.0*t.h/2;
	double w2=1.0*t.w/2;
	double h=t.h;
	double w=t.w;
	if(k==0) return new Complex(x+h2,y+w);
	if(k==1) return new Complex(x,y+w2);
	if(k==2) return new Complex(x+h2,y);
	if(k==3) return new Complex(x+h,y+w2);
	return(new Complex());
    }

    /**a and b are the type; i and j are the indices*/


    public static boolean good(int a,int b,int i,int j) {
	if(good(a,i,j)==true) return(true);
	if(good(b,i,j)==true) return(true);
	return(false);
    }

    public static boolean good(int a,int i,int j) {
	int test1=(i+j+10)%2;
	if(test1==0) return(false);
	int[][] good={{0,0,-1},{2,0,1},{1,-1,0},{3,1,0}};
	for(int k=0;k<4;++k) {
	    if((a==good[k][0])&&(i==good[k][1])&&(j==good[k][2])) return true;
	}
	return(false);
    }





}


