import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PlaidPETSlicer extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    ControlPanel TILE;
    ListenSquare CONTROL;
    ListenSquare[] JUMP=new ListenSquare[9];
    Point JX;
    boolean DRAG;

    public PlaidPETSlicer() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(200,140,90);	
	 CONTROL=new ListenSquare(0,0,300,50);
	 for(int i=0;i<9;++i) JUMP[i]=new ListenSquare(45*i,0,15,15);
	 DRAG=false;
     }

    public double getSlice() {
	return SOURCE.x;
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
      drawElevation(g);
      drawControls(g);
   }

    public void drawControls(Graphics2D g) {
      CONTROL.w=this.getWidth()-1;
      CONTROL.render(g,Color.blue);
      for(int i=0;i<9;++i) JUMP[i].render(g,new Color(0,160,0));
      String[] S={"-2","-1-P","-1","-1+P","0","1-P","1","1+P","2"};
      int[] x={10,42,92,130,184,224,274,313,363};
      g.setColor(Color.white); 
      g.setFont(new Font("Helvetica",Font.PLAIN,11));
      for(int i=0;i<9;++i) g.drawString(S[i],x[i],30);
    }


    public void drawElevation(Graphics2D g) {
	int p=M.C.PAR.getNumerator();
	int q=M.C.PAR.getDenominator();
	double P=Torus.P(p,q);
	Path2D.Double gp=new Path2D.Double();



	int[][] type={{3,3},{1,1},{0,2},{2,0},{0,2},{2,0},{3,3},{1,1}};

	for(int i=0;i<8;++i) {
	    for(int j=-3;j<4;++j) {
		for(int k=-3;k<4;++k) {
		    gp=piece(i,j,k,P);
	            gp=transform(gp);
	            g.setColor(M.C.PPC.TYPE[type[i][0]][type[i][1]].C);
	            g.fill(gp);
		    g.setColor(Color.white);
		    g.draw(gp);
		}
	    }
	}

	drawFrame(g);
    }


    public void drawFrame(Graphics2D g) {

	Path2D.Double gp=new Path2D.Double();

	for(int i=-1;i<2;i=i+2) {
	  gp.reset();
	  gp.moveTo(-50,-1*i);
	  gp.lineTo(50,-1*i);
	  gp.lineTo(50,-10*i);
	  gp.lineTo(-50,-10*i);
	  gp.closePath();
	  gp=transform(gp);
	  g.setColor(new Color(0,0,0,100));
	  g.fill(gp);
	}

	for(int i=-1;i<2;i=i+2) {
	  gp.reset();
	  gp.moveTo(-2*i,-1);
	  gp.lineTo(-10*i,-1);
	  gp.lineTo(-10*i,1);
	  gp.lineTo(-2*i, 1);
	  gp.closePath();
	  gp=transform(gp);
	  g.setColor(new Color(0,0,0,100));
	  g.fill(gp);
	}


	for(int i=-5;i<7;i=i+2) {
	  gp.reset();
	  gp.moveTo(-10,i);
	  gp.lineTo( 10,i);
	  gp=transform(gp);
	  g.setColor(Color.white);
	  g.draw(gp);
	}

	gp.moveTo(-2,-1);
	gp.lineTo(-2, 1);
	gp.lineTo( 2, 1);
	gp.lineTo( 2,-1);
	gp.closePath();
	gp=transform(gp);
	g.setColor(Color.white);
	g.setStroke(new BasicStroke(3));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));


	gp.reset();
	gp.moveTo(SOURCE.x,-1);
	gp.lineTo(SOURCE.x,1);  
        gp=transform(gp);
	g.setStroke(new BasicStroke(2));
	g.setColor(new Color(120,180,255));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));



    }



    public static Path2D.Double piece(int i,int j,int k,double P) {
	Path2D.Double gp=pieceFlipped(i,j,k,P);
	AffineTransform A=new AffineTransform(0,1,1,0,0,0);
	gp.transform(A);
	return(gp);
    }



    public static Path2D.Double pieceFlipped(int i,int j,int k,double P) {
	if(i==0) return piece0(j,k,P);
	if(i==1) return piece1(j,k,P);
	if(i==2) return piece2(j,k,P);
	if(i==3) return piece3(j,k,P);
	if(i==4) return piece4(j,k,P);
	if(i==5) return piece5(j,k,P);
	if(i==6) return piece6(j,k,P);
	if(i==7) return piece7(j,k,P);
	return(null);
    }

    public static Path2D.Double piece0(int j,int k,double P) {
	double x=2*j+P*k;
	double y=2*k;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1+x,-1+y);
	gp.lineTo(1-P+x,-1+y);
	gp.lineTo(1-P+x,1-P+y);
	gp.closePath();
	return(gp);
    }

    public static Path2D.Double piece1(int j,int k,double P) {
	double x=2*j+P*k;
	double y=2*k;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(1+x,1+y);
	gp.lineTo(-1+P+x,1+y);
	gp.lineTo(-1+P+x,-1+P+y);
	gp.closePath();
	return(gp);
    }

    public static Path2D.Double piece2(int j,int k,double P) {
	double x=2*j+2*P*k;
	double y=4*k;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1+x,-1+y);
	gp.lineTo(-1+P+x,-1+P+y);
	gp.lineTo(-1+P+x,1+y);
	gp.lineTo(-1+x,1-P+y);
	gp.closePath();
	return(gp);
    }

    public static Path2D.Double piece3(int j,int k,double P) {
	double x=2*j+2*P*k+P;
	double y=4*k+2;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1+x,-1+y);
	gp.lineTo(-1+P+x,-1+P+y);
	gp.lineTo(-1+P+x,1+y);
	gp.lineTo(-1+x,1-P+y);
	gp.closePath();
	return(gp);
    }

    public static Path2D.Double piece4(int j,int k,double P) {
	double x=2*j+2*P*k;
	double y=4*k+2;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1+x,-1+y);
	gp.lineTo(-1+P+x,-1+P+y);
	gp.lineTo(-1+P+x,1+y);
	gp.lineTo(-1+x,1-P+y);
	gp.closePath();
	return(gp);
    }


    public static Path2D.Double piece5(int j,int k,double P) {
	double x=2*j+2*P*k+(2-P);
	double y=4*k;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1+x,-1+y);
	gp.lineTo(-1+P+x,-1+P+y);
	gp.lineTo(-1+P+x,1+y);
	gp.lineTo(-1+x,1-P+y);
	gp.closePath();
	return(gp);
    }


    public static Path2D.Double piece6(int j,int k,double P) {
	double x=2*j+P*k;
	double y=2*k;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1+x,1-P+y);
	gp.lineTo(-1+x,1+y);
	gp.lineTo(-1+P+x,1+y);
	gp.closePath();
	return(gp);
    }


    public static Path2D.Double piece7(int j,int k,double P) {
	double x=2*j+P*k;
	double y=2*k;
 	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(1+x,-1+P+y);
	gp.lineTo(1+x,-1+y);
	gp.lineTo(1-P+x,-1+y);
	gp.closePath();
	return(gp);
    }



    public void process(Point X) {
	int p=M.C.PAR.getNumerator();
	int q=M.C.PAR.getDenominator();
	double P=Torus.P(p,q);
	double[] t={-1.99999,-1-P,-1,-1+P,0,1-P,1,1+P,1.99999};
	for(int i=0;i<9;++i) {
	    if(JUMP[i].inside(X)==1) SOURCE.x=t[i];
	}
    }
	    




    public void mousePressed(MouseEvent e) { }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) { 
	if(CONTROL.inside(JX)==0) {
          if(mode==1)  scaleUp(JX,0);
          if(mode==2)  SOURCE=unTransform(JX);
          if(mode==3)  scaleUp(JX,1);

	}
	else{
	    process(JX);
	}
	repaint();
	M.Q.repaint();
    }




    public void mouseDragged(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	if(CONTROL.inside(J.X)==0) {
             SOURCE=unTransform(J.X);
	}
	repaint();
	M.Q.repaint();
    }

    public void doMouseDrag() {
	if(CONTROL.inside(JX)==0) {
          SOURCE=unTransform(JX);
	}
	repaint();
	M.Q.repaint();
    }


    public void mouseReleased(MouseEvent e) {}

    public void mouseEntered(MouseEvent e) {
	requestFocus();
    }

    public void mouseExited(MouseEvent e) {}   
    public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	JX=J.X;
	if(DRAG==true) doMouseDrag();
    }


    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
	int test=0;
	if(ch=='z') test=1;
	if(ch=='x') test=2;
	if(ch=='c') test=3;
	if(test>0) doMouseClick(test);
    }

 
    public void keyPressed(KeyEvent e) {
	DRAG=true;
    }
    public void keyReleased(KeyEvent e) {
	DRAG=false;
    }

}

