import java.applet.Applet;
import java.awt.*;
import java.applet.*;
import java.math.*;
import java.awt.event.*;
import java.awt.geom.*;

public class DebugRational {

    /**This tests various inequalities between rational
       numbers, as part of the second paper.*/

    public static void main() {
	int count=0;
	int badcount=0;
	for(int q=2;q<2000;++q) {
	    System.out.println("frak test "+q+" "+count+" "+badcount);
	    for(int p=1;p<q;++p) {
		int[] P=MathRational.reduce(p,q);
		int k=test(P[0],P[1]);
		if(k==1) ++count;
		if(k==-1)  {
                    ++badcount;
		    System.out.println("             "+P[0]+"/"+P[1]);
		}
	    }  
	}
    }

     public static int test1(int p,int q) {
	if((p*q)%2==1) return(0);
	if(p==1) return(0);
	int k=MathRational.coreNumber(p,q);
	if(k==0) return(0);
	int[] A=MathRational.corePredecessor(p,q);
	int t1=MathRational.tune(A[0],A[1]);
	int t2=MathRational.tune(p,q);
	double d1=PlaidFunctions.FV(A[0],A[1],t1,0);
	double d2=PlaidFunctions.FV(p,q,t2,0);
	double rat=d1/d2;
	System.out.println("ratio "+rat);


	return(-1);
    }

     public static int test(int p,int q) {
	if((p*q)%2==1) return(0);
	if(p==1) return(0);
	int k=MathRational.coreNumber(p,q);
	if(k==0) return(0);
	int[] A=MathRational.corePredecessor(p,q);
	int t=MathRational.tune(A[0],A[1]);
	int u=A[0]+A[1];
	double d0=8*k*t;
	double d2=4*(p+q);
	if(d0>=d2) return(-1);
	return(1);
    }



}


