import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentHexagrid {

    public static void basic(DocumentCanvas D) {

	String S="Hexagrid selector";
	S=S+"\n\nThe plaid model is defined in terms of 6 families of lines.  Together these lines comprise what we call the hexagrid.  My papers all give precise definitions of the hexagrid. Here are some general features of the lines:";
	S=S+"\n\nAll the non-vertical lines intersect the Y-axis at integer points.  The weight and sign associated to the line is determined by this intersection point.  The vertical lines intersect the X axis in integer points, and the weight and sign is determined by these intersections.";

	S=S=S+"\n\nAll the lines in the same family have the same slope.";

	S=S+"\n\nHalf the lines in the family have positive sign and the other half have negative slope.  The signs are symmetrically arranged.  The line through (0,Y) has positive sign if and only if the line through (0,W-Y) has negative sign.  Here W=p+q, where the parameter is p/q.";

	S=S+"\n\nThis control panel lets you select and recolor the lines from one of the 6 families.  Looking at the right hand side of this control panel, there is a sequence of numbers, either odd or even.  There are two boxes corresponding to each of these numbers. The top box activates the grid line having the given weight and positive sign.  The bottom box activates the grid line having given weight and negative sign.";

	S=S+"\n\nIn order to see the effects of your clicks, you need to have the planar window open and the hexagrid feature turned on.";

	S=S+"\n\nThere are p+q lines in each family, but these control panels only let you see the first 30 or so from each family.  If you really want to see higher weight lines, you can use the arrow keys at the bottom of these windows.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


    public static void advanced(DocumentCanvas D) {

	String S="Additional Hexagrid Selection";

	S=S+"\n\nThis explansion assumes that you have read the documentation for the hexagrid selection panels.  You access this documentation by clicking on any of the 6 question boxes at the top of this window.";

	S=S+"\n\nThe green boxes activate this feature.";

	S=S+"\n\nThe arrow keys control the weight of the selected line and the row of two blue squares controls the sign (+/-) of the line selected.\n\n  For example, if you wanted to see the line of capacity 22 and sign (-) from the V family, you would activate the green button beneath the second control panel, choose the right blue square, then change the arrows to read 22. If course, this example would only be meaningful if p+q>22.";

	S=S+"\n\nOne last control: If you click on the bottom rectangles it will turn off all the lines within the selected family.";
 
        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }

}


