import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class GraphPETInterpreter extends ScaleCanvas implements MouseListener {
    Manager M;
    int[] type=new int[2];

    public GraphPETInterpreter() {
	addMouseListener(this);
	setScales(150,150,100);
	type[0]=1;
	type[1]=1;
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
      renderLattice(g);
      renderLattice(g,type[0],type[1]);
   }



    public void renderLattice(Graphics2D g,int i,int j) {
	int p=M.p();
	int q=M.q();
	Path2D.Double gp=new Path2D.Double();
	Complex Z=AGLattice.shortVector(p,q,i-1,j-1);
	gp.moveTo(0,0);
	gp.lineTo(Z.x,Z.y);
	gp=transform(gp);
	g.setColor(GraphPETColors.COLOR[i][j]);
	g.setStroke(new BasicStroke(6));
	g.draw(gp);  
        g.setStroke(new BasicStroke(1));
    }



    public void renderLattice(Graphics2D g) {
	int p=M.p();
	int q=M.q();
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		gp.reset();
	        Complex Z=AGLattice.shortVector(p,q,i-1,j-1);
	        gp.moveTo(0,0);
	        gp.lineTo(Z.x,Z.y);
	        gp=transform(gp);
	        g.setColor(new Color(80,90,100));
	        g.draw(gp);  
	    }
	}
    }





    public void mouseClicked(MouseEvent e) {
	MouseData J=MouseData.process(e);
        if(J.mode==1)  scaleUp(J.X,0);
        if(J.mode==3)  scaleUp(J.X,1);
	M. repaint();
    }
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}   

}


