import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PolytopeRandom {

    /**picks a random point in a polytope*/
    public static Vector4 random(Polytope P) {
	Vector4 W=new Vector4();
	double[] d=new double[P.count];
	double sum=0;
	for(int i=0;i<P.count;++i) {
	    d[i]=Math.random();
	    sum=sum+d[i];
	}
	for(int i=0;i<P.count;++i) d[i]=d[i]/sum;
	for(int i=0;i<P.count;++i) {
	    W=Vector4.plus(W,P.V[i].scale(d[i]));
	}
	return(W);
    }

    /**cheap way of taking the convex hull*/

    public static Polytope cheapHull(Polytope P) {
	int count=0;
	Polytope Q=new Polytope();
	for(int i=0;i<10000;++i) {
	    Vector4 W=randomExtreme(P);
	    Q.count=count;
	    boolean test=onList(W,Q);
	    if(test==false) {
		Q.V[count]=new Vector4(W);
		++count;
	    }
	}
	return Q;
    }

    /**Checks if a vector is a vertex of the polytope*/

    public static boolean onList(Vector4 W,Polytope P) {
	for(int i=0;i<P.count;++i) {
	    if(Vector4.dist2(W,P.V[i])<.000001) return true;
	}
	return(false);
    }

    /**Gets a random vector in [-1,1]^4*/

    public static Vector4 randomVector() {
	Vector4 V=new Vector4();
	for(int i=0;i<4;++i) V.x[i]=1-2*Math.random();
	return V;
    }

    /**gets a random extreme point*/
    public static Vector4 randomExtreme(Polytope P) {
	int index=0;
	Vector4 W=randomVector();
	double max=-10000;
	for(int i=0;i<P.count;++i) {
	    double test=Vector4.dot(P.V[i],W);
	    if(max<test) {
		max=test;
		index=i;
	    }
	}
	return(P.V[index]);
    }
}












