import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**This checks that various of the polyhedra are disjoint from
   various other ones.*/


public class ProofConvex {


    public static void main() {
	testPlaid();
	testGraph();
	testGraphDouble();
	testGraphTriple();
	testPlaidTriple();
    }



    public static void testPlaid() {
	System.out.println("start plaid convex ");
	for(int i=0;i<26;++i) {
           PolytopeLong P=AllPolytopesLong.plaid(i);
	   boolean test=P.isCleanConvex();
	   if(test==false) throw new ProofException("fail");
	}
	System.out.println("done");
    }

    public static void testGraph() {
	System.out.println("start graph convex ");
	for(int i=0;i<28;++i) {
           PolytopeLong P=AllPolytopesLong.graph(i);
	   boolean test=P.isCleanConvex();
	   if(test==false) throw new ProofException("fail");
	}
	System.out.println("done");
    }

    public static void testGraphDouble() {
	System.out.println("start graph double convex ");
	for(int i=0;i<9;++i) {
           PolytopeLong P=AllPolytopesLong.graphDouble(i);
	   boolean test=P.isCleanConvex();
	   if(test==false) throw new ProofException("fail");
	}
	System.out.println("done");
    }


    public static void testGraphTriple() {
	System.out.println("start graph triple convex ");
	for(int i=0;i<218;++i) {
           PolytopeLong P=AllPolytopesLong.graphTriple(i);
	   boolean test=P.isCleanConvex();
	   if(test==false) throw new ProofException("fail");
	}
	System.out.println("done");
    }


    public static void testPlaidTriple() {
	System.out.println("start plaid triple convex ");
	for(int i=0;i<218;++i) {
           PolytopeLong P=AllPolytopesLong.plaidTriple(i);
	   boolean test=P.isCleanConvex();
	   if(test==false) throw new ProofException("fail");
	}
	System.out.println("done");
    }



}


