import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**This shows that there are no errant edges*/

public class ProofErrantEdge {

    public static void main() {
	System.out.print("errant edge test: start ");
	for(int i=0;i<462;++i) {
	    int[] t=DataEdgeCrossing.index(i);
	    int[] u=DataTripleCodes.data(t[0]);
	    int test1=DataTripleIndex.ordering(t[0]);
	    int test2=t[1];
	    int[] x={u[4],u[5],t[2]};
	    if(test1==test2) {
		x[0]=u[1];
		x[1]=u[0];
	    }
	    boolean test=forbidden(x);
	    if(test==true) throw new ProofException("errant edge");
	}
	System.out.println("done");
    }

    /**Here are the forbidden configurations.
       As usual, the numbers 0,...,7 represent
       the graph edges arrayed according to the 
       following scheme:

       247
       1 6
       035
    */

    public static boolean forbidden(int[] x) {
	int[][] a1={{1,3},{3,1}};
	int[] b1={1,2,5,6};

	int[][] a2={{0,2},{2,0}};
	int[] b2={0,3,4,7};

	int[][] a3={{1,0},{3,0}};
	int[] b3={1,2};

	int[][] a4={{1,2},{3,2}};
	int[] b4={5,6};

	int[][] a5={{2,3},{0,3}};
	int[] b5={0,3};

	int[][] a6={{2,1},{0,1}};
	int[] b6={4,7};

	int[][][] A={a1,a2,a3,a4,a5,a6};
	int[][] B={b1,b2,b3,b4,b5,b6};


	for(int k=0;k<3;++k) {
	    for(int i=0;i<A[k].length;++i) {
	        for(int j=0;j<4;++j) {
		    int[] a=A[k][i];
		    int b=B[k][i];
		    if((x[0]==a[0])&&(x[1]==a[1])&&(x[2]==b)) return true;
		}
	    }
	}
	return false;
    }


}
