import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**This checks that each graph triple is contained in the corresponding
graph polytope, either a graph single or (in the last 38 cases) a
graph double*/

public class ProofPlaidGraph {


    public static void main() {
	System.out.println("start");
	for(int i=0;i<218;++i) {
	    boolean test1=testPlus(i);
	    boolean test2=testMinus(i);
	    if(test1==false) throw new ProofException("container test plus fails "+i);
	    if(test2==false) throw new ProofException("container test minus fails "+i);
	}
	System.out.println("done");
    }


    public static boolean testPlus(int i) {
	if(i<180) return singleTestPlus(i);
	if(i>199) return singleTestPlus(i);
	return doubleTest(i);
    }

    public static boolean testMinus(int i) {
	if(i<199) return singleTestMinus(i);
	return doubleTest(i);
    }


    public static boolean singleTestPlus(int i) {
        PolytopeLong P=AllPolytopesLong.graphTriple(i);
	int[][] c=DataTripleIndex.indexPlus(i);
	PolytopeLong Q=AllPolytopesLong.graph(c[0]); 
	boolean test=Q.contains(P);
	return test;
    }

    public static boolean singleTestMinus(int i) {
        PolytopeLong P=AllPolytopesLong.graphTriple(i);
	int[][] c=DataTripleIndex.indexMinus(i);
	PolytopeLong Q=AllPolytopesLong.graph(c[0]); 
	boolean test=Q.contains(P);
	return test;
    }


    public static boolean doubleTest(int i) {
        PolytopeLong P=AllPolytopesLong.graphTriple(i);
	int choice=DataGraphDoubles.whichContainer(i);
	PolytopeLong Q=AllPolytopesLong.graphDouble(choice);
	boolean test=Q.contains(P);
	return test;
    }


}


