import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class SpiderControl {
    Manager M;
    int X,Y;
    ListenSquare[][] A=new ListenSquare[3][3];
    ListenSquare[][] B=new ListenSquare[3][3];
    ListenSquare[] E=new ListenSquare[4];
    ListenSquare[] F=new ListenSquare[4];
    ListenSquare[] INFO=new ListenSquare[3];
    int[][] on=new int[3][3];
    int choice;
    Color[] COL=new Color[4];
    ControlPanel MODE;
    int EDGE;
    SelectInteger AVOID,PROBLEM;
    Lever JUMP;

    public SpiderControl(Manager m,int x,int y) {
	X=x;
	Y=y;
	M=m;
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		A[i][j]=new ListenSquare(X+60*i,Y+145-60*j,60,60);
		B[i][j]=new ListenSquare(20+X+60*i,Y+165-60*j,20,20);
	    }
	}
	E[0]=new ListenSquare(X+20,Y+445,140,20);
	E[1]=new ListenSquare(X+00,Y+305,20,140);
	E[2]=new ListenSquare(X+20,Y+285,140,20);
	E[3]=new ListenSquare(X+160,Y+305,20,140);

	F[0]=new ListenSquare(X+83,Y+451,14,14);
	F[1]=new ListenSquare(X+00,Y+368,14,14);
	F[2]=new ListenSquare(X+83,Y+285,14,14);
	F[3]=new ListenSquare(X+166,Y+368,14,14);
	INFO[0]=new ListenSquare(X,Y+220,12,12);
	INFO[1]=new ListenSquare(X,Y+288,12,12);
	INFO[2]=new ListenSquare(X+60,Y+85,12,12);

	COL[0]=new Color(40,50,60);
	COL[1]=new Color(90,100,110);
	COL[2]=new Color(150,160,170);
        COL[3]=new Color(200,210,220);
	choice=-1;
	setControlPanel();
	EDGE=0;	
	/**choices here are 204,462*/
        AVOID=new SelectInteger(X+10,Y+230,60,30,0,0,462,1);
        PROBLEM=new SelectInteger(X+110,Y+235,40,20,0,0,46,1);
	JUMP=new Lever(X,Y+210,0,16);
    }


    public void setControlPanel() {
	Color[] C0={new Color(90,0,255),
         Color.white,Color.white,Color.white,Color.red};
	 String[] MainString={
	     "off",
	     "unresricted",
	     "restricted",
             "display mode"};
	 int[] MainState={1,0,0};
         MODE=new ControlPanel(C0,MainString,MainState,3);
    }


    public boolean isSpecial(int k) {
	int[] J=DataEdgeCrossing.index(k);
	for(int i=0;i<46;++i) {
	    int[] I=DataEdgeCrossing.recalcitrant(i);
	    if(ListHelp.match(I,J)==true) return true;
	}
	return false;
    }


    public void render(Graphics2D g,int p,int q) {
	g.setColor(Color.black);
	g.fillRect(X,Y-45,180,510);
	g.setColor(Color.white);
	g.drawRect(X,Y-45,180,510);
	for(int i=0;i<3;++i) INFO[i].infoRender(g);


	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		if((i!=1)||(j!=1)) {
		    Color C=GraphPETColors.COLOR[i][j];
		    A[i][j].render(g,C);
		    C=new Color(200,0,200);
		    if(choice==convert(i,j)) C=new Color(255,50,0);
		}
	    }
	}

	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		if((i!=1)||(j!=1)) {
		    if(on[i][j]==1) B[i][j].render(g,Color.white);
		}
	    }
	}


	MODE.render(g,X+72,Y-45,108);
	g.setColor(Color.white); 
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.drawString("edge crossing problems",X+10,Y+278);
	boolean test=isSpecial(AVOID.val);
	Color C=new Color(0,200,0);
	if(test==true) C=new Color(200,0,0);
	AVOID.render(g,C,Color.white,Color.white);
	PROBLEM.render(g,new Color(200,0,0),Color.white,Color.white);
	JUMP.render2(g,"",new Color(0,200,0));
	renderLattice(g,p,q);
    }

    public void renderLattice(Graphics2D g,int p,int q) {
	for(int i=0;i<4;++i) {
             E[i].render(g,COL[i]);
	     if((MODE.mode==2)&&(i!=EDGE)) F[i].render(g,Color.blue);
	     if((MODE.mode==2)&&(i==EDGE)) F[i].render(g,Color.yellow);
	}


	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		gp.reset();  
                g.setStroke(new BasicStroke(1));
		Complex Z=AGLattice.shortVector(p,q,i-1,j-1);
		gp.moveTo(X+90,Y+375);
		gp.lineTo(X+90+60*Z.x,Y+375-60*Z.y);
	        g.setColor(new Color(80,80,80));
		if(on[i][j]==1) {
		    g.setColor(GraphPETColors.COLOR[i][j]);
		     g.setStroke(new BasicStroke(6));
		}
		g.draw(gp);  
                g.setStroke(new BasicStroke(1));
	    }
	}
    }


    /**The 8 local arithmetic graph types are enumerated 0,...,7.
       This gives the correspondence between them. Note that the
       indices are shifted by +1. in the listing, for the usual 
       reason that arrays in Java are indexed by non-negative
       integers.  So, for instance {0,0} corresponds to the local
       AG type (-1,-1).   Geometrically it looks like this:

 
              2   4   7

              1       6
   
              0   3   5

    */

    public static int[] convert(int k) {
 	int[][] K={{0,0},{0,1},{0,2},{1,0},{1,2},{2,0},{2,1},{2,2}};
	return K[k];
    }

    /**This inverts the conversion*/

    public static int convert(int i,int j) {
	int[][] K={{0,0},{0,1},{0,2},{1,0},{1,2},{2,0},{2,1},{2,2}};
	for(int k=0;k<8;++k) {
	    if((i==K[k][0])&&(j==K[k][1])) return(k);
	}
	return(-1);
    }



    public int[][] getOn() {
	int[][] LIST=new int[8][2];
	int count=0;
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		if(on[i][j]==1) {
		    LIST[count][0]=i-1;
		    LIST[count][1]=j-1;
		    ++count;
		}
	    }
	}
	return(ListHelp.trim(LIST,count));
    }


    public void documentStuff(Point X) {
	try{
	  if(MODE.L[20].inside(X)==1) DocumentPartition.spider(M.D);
	  if(INFO[0].inside(X)==1) DocumentPartition.edge(M.D);
	  if(INFO[1].inside(X)==1) DocumentPartition.square(M.D);
	  if(INFO[2].inside(X)==1) DocumentPartition.graph(M.D);
	}
	catch(Exception e) {}
    }


    public boolean avoidPresets(Point X) {
	int[] jump={0,50,60,75,111,115,138,154,231,308,324,347,351,366,402,452};
	int t=JUMP.process(X);
	boolean test=false;
	if(t!=-1) {
	    AVOID.val=jump[JUMP.val];
	    test=true;
	}
	return(test);
    }

    public void setAvoid(Point X) {
	AVOID.modifyCyclic(X);
	PROBLEM.modifyCyclic(X);
	boolean test=avoidPresets(X);
	int aa=AVOID.isModified(X);
	int bb=PROBLEM.isModified(X);
	if(bb==1) {
	    int[] I=DataEdgeCrossing.recalcitrant(PROBLEM.val);
	    for(int i=0;i<462;++i) {
		int[] J=DataEdgeCrossing.index(i);
		if(ListHelp.match(I,J)==true) AVOID.val=i;
	    }
	}

	if((test==true)||(aa==1)||(bb==1)) {
	    int[] t=DataEdgeCrossing.index(AVOID.val);
	    M.C.GRAPH.L[0].on=0;
	    M.C.GRAPH.L[1].on=1;
	    M.C.GRAPH.L[2].on=0;
	    M.C.GRAPH.L[3].on=1;
	    M.C.GRAPH.L[4].on=0;
	    M.C.GRAPH.L[5].on=1;
	    M.C.PLAID.L[0].on=0;
	    M.C.PLAID.L[1].on=0;
	    M.C.PLAID.L[2].on=1;
	    M.C.PLAID.L[3].on=1;
	    M.C.PLAID.L[4].on=1;
	    M.Z.TS.SELECT.val=t[0];
	    int[] code=DataTripleCodes.data(t[0]);
	    M.Z.TS.acceptCode(code);
	    try{
		M.GS.PARTITION.forceMode(t[1]);
		M.GS.LOCK.forceMode(1);
		M.GS.DIRECTION.forceMode(2);
		M.GS.setProjectionCenter();
		M.QS.LOCK.forceMode(1);
		M.QS.DIRECTION.forceMode(2);
		M.QS.setProjectionCenter();
	    }
	    catch(Exception e) {}
	    MODE.forceMode(2);
	    for(int i=0;i<3;++i) {
		for(int j=0;j<3;++j) {
		    on[i][j]=0;
		}
	    }
	    int[] I=convert(t[2]);
	    on[I[0]][I[1]]=1;
	    EDGE=t[3];
	}
    }

    public void process(Point X,Color C) {
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		if(A[i][j].inside(X)==1) {
                       on[i][j]=1-on[i][j];
		}
	    }
	}
	for(int i=0;i<4;++i) {
	    if(F[i].inside(X)==1) {
                EDGE=i;
	    }
	    if((E[i].inside(X)==1)&&(F[i].inside(X)==0)) COL[i]=C;
	}

	MODE.switchMode(X);
	setAvoid(X);
	documentStuff(X);


    }


}